diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 3ef5d30fc..0254e9be9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -6,9 +6,15 @@ import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.particle.ParticleBlockBreaking;
 import net.minecraft.client.render.particle.Particle;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
+import net.minecraft.client.render.tessellator.TessellatorParticleShader;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.Block;
@@ -16,18 +22,16 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 /**
  * Handles rendering and ticking of client-side particles.
  */
 public final class ParticleEngine {
-    public static final int PARTICLE_TEXTURE = 0;
-    public static final int TERRAIN_TEXTURE = 1;
-    public static final int ITEM_TEXTURE = 2;
-    public static final int ENTITY_PARTICLE_TEXTURE = 3;
-    public static final int TEXTURE_COUNT = 4;
+    public static final int WORLD_TEXTURE = 0;
+    public static final int ENTITY_PARTICLE_TEXTURE = 1;
+    public static final int TEXTURE_COUNT = 2;
 
+    private final @NotNull TessellatorParticleShader shaderParticleTessellator = new TessellatorParticleShader(4000 * 40);
     private World world;
     private final List<Particle>[] particles;
     private final Random rand;
@@ -54,6 +58,7 @@ public final class ParticleEngine {
             this.particles[t].remove(0);
         }
         this.particles[t].add(p);
+        p.init();
     }
 
     /**
@@ -77,23 +82,25 @@ public final class ParticleEngine {
      * @param camera      The camera relative to whose perspective the particles should be drawn.
      * @param partialTick The time since the last tick.
      */
-    public void renderParticles(@NotNull ParticleTessellator tessellator, @NotNull ICamera camera, float partialTick) {
+    public void renderParticles(@NotNull ICamera camera, float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.PARTICLE);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setDepthFunc(CompareFunc.LESS);
+
+        TessellatorParticle tessellator = this.shaderParticleTessellator;
         tessellator.setupParticleValues(camera, partialTick);
         double xOff = camera.getX(partialTick);
         double yOff = camera.getY(partialTick);
         double zOff = camera.getZ(partialTick);
 
-        for (int tt = 0; tt < 3; tt++) {
+        for (int tt = 0; tt <= WORLD_TEXTURE; tt++) {
             if (this.particles[tt].isEmpty()) {
                 continue;
             }
-            int texture = switch (tt) {
-                case PARTICLE_TEXTURE -> TextureRegistry.particleAtlas.id();
-                case TERRAIN_TEXTURE -> TextureRegistry.blockAtlas.id();
-                case ITEM_TEXTURE -> TextureRegistry.itemAtlas.id();
-                default -> 0;
-            };
-            GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture);
+            TextureRegistry.worldAtlas.bind();
             tessellator.setTranslation(-xOff, -yOff, -zOff);
             tessellator.startDrawingParticles();
             for (int i = 0; i < this.particles[tt].size(); i++) {
@@ -103,6 +110,7 @@ public final class ParticleEngine {
             tessellator.drawParticles();
         }
         tessellator.setTranslation(0, 0, 0);
+        GLRenderer.popFrame();
     }
 
     /**
@@ -121,7 +129,7 @@ public final class ParticleEngine {
         double xOff = camera.getX(partialTick);
         double yOff = camera.getY(partialTick);
         double zOff = camera.getZ(partialTick);
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         for (int i = 0; i < this.particles[tt].size(); i++) {
             Particle p = this.particles[tt].get(i);
             p.renderLit(tessellator, partialTick, xOff, yOff, zOff);
@@ -206,6 +214,6 @@ public final class ParticleEngine {
     }
 
     public int countParticles() {
-        return this.particles[PARTICLE_TEXTURE].size() + this.particles[TERRAIN_TEXTURE].size() + this.particles[ITEM_TEXTURE].size() + this.particles[ENTITY_PARTICLE_TEXTURE].size();
+        return this.particles[WORLD_TEXTURE].size() + this.particles[ENTITY_PARTICLE_TEXTURE].size();
     }
 }
